--- src/npw-wrapper.c.orig	2011-03-30 19:53:27.000000000 -0400
+++ src/npw-wrapper.c	2011-03-30 19:54:15.000000000 -0400
@@ -30,6 +30,7 @@
 #include <unistd.h>
 #include <signal.h>
 #include <semaphore.h>
+#include <signal.h>
 #include <sys/wait.h>
 
 #include <glib.h>
@@ -2560,6 +2561,24 @@
   return ret;
 }
 
+#define	NPW_ADOBE_FLASH_NAME	"Shockwave Flash"
+
+// Detect Adobe Flash plugin version
+static float is_adobe_flash(void)
+{
+  static float version = 0.0;
+  static bool tested = false;
+
+  if (!tested) {
+	if (strcmp(g_plugin.name, NPW_ADOBE_FLASH_NAME) == 0 &&
+	    strncmp(g_plugin.description, NPW_ADOBE_FLASH_NAME,
+	    strlen(NPW_ADOBE_FLASH_NAME)) == 0)
+		version = strtof(g_plugin.description + strlen(NPW_ADOBE_FLASH_NAME), NULL);
+	tested = true;
+  }
+  return version;
+}
+
 static int16 g_NPP_HandleEvent(NPP instance, void *event)
 {
   if (instance == NULL)
@@ -2569,6 +2588,13 @@
   if (plugin == NULL)
 	return NPERR_INVALID_INSTANCE_ERROR;
 
+  if (((NPEvent *)event)->type == ButtonPress &&
+      ((XButtonEvent *)event)->button == Button3 &&
+      is_adobe_flash() >= 10.1) {
+	/* XXX: work around "right click" hang with Flash plugin 10.1 and later */
+	D(bug("NPP_HandleEvent instance=%p: Button3 pressed on SWF\n", instance));
+	return true;
+  }
   if (((NPEvent *)event)->type == GraphicsExpose) {
 	/* XXX: flush the X output buffer so that the call to
 	   gdk_pixmap_foreign_new() in the viewer can work */

